import { RedBlackTreeImpl, ComparatorFn } from './RedBlackTree';
import { Node } from './node';
import { PathNode } from './path';
export declare function findNodeByKey<K, V>(key: K, tree: RedBlackTreeImpl<K, V>): Node<K, V> | undefined;
export declare function findIndex<K, V>(key: K, node: Node<K, V>, compare: ComparatorFn<K>): number;
export declare function findPathToNodeByKey<K, V>(key: K, node: Node<K, V>, compare: ComparatorFn<K>): PathNode<K, V>;
export declare function findMaxNodeLeftOfKey<K, V>(allowExactKeyMatch: boolean, key: K, tree: RedBlackTreeImpl<K, V>): Node<K, V> | undefined;
export declare function findPathToMaxNodeLeftOfKey<K, V>(allowExactKeyMatch: boolean, key: K, node: Node<K, V>, parent: PathNode<K, V>, compare: ComparatorFn<K>): PathNode<K, V> | undefined;
export declare function findMinNodeRightOfKey<K, V>(allowExactKeyMatch: boolean, key: K, node: Node<K, V>, compare: ComparatorFn<K>): Node<K, V> | undefined;
export declare function findPathToMinNodeRightOfKey<K, V>(allowExactKeyMatch: boolean, key: K, node: Node<K, V>, parent: PathNode<K, V>, compare: ComparatorFn<K>): PathNode<K, V> | undefined;
export declare function findByIndex<K, V>(index: number, tree: RedBlackTreeImpl<K, V>): Node<K, V> | undefined;
export declare function findPathToIndex<K, V>(index: number, node: Node<K, V>): PathNode<K, V>;
